﻿using combit.ListLabel25;
using combit.ListLabel25.DataProviders;
using combit.ListLabel25.Dom;
using combit.ListLabel25.Repository;
using Microsoft.VisualBasic;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace llrepotest
{
    public partial class Form1 : Form
    {

        private DirectoryBasedFileRepository _repository;

        private DirectoryBasedFileRepository CurrentRepository
        {
            get
            {
                if (_repository == null)
                {
                    _repository = new DirectoryBasedFileRepository(textBox1.Text);
                    textBox1.Enabled = false;
                }
                return _repository;
            }
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            textBox1.Text = Path.Combine(Path.GetTempPath(), "TestRepo"); // + new Random(DateTime.Now.Millisecond).Next(1000, 9999));
            btnRefreshRepoList.PerformClick();
        }


        string rootId = String.Empty;
        string templateId = String.Empty;
        private void button1_Click(object sender, EventArgs e)
        {
            using (var LL = new ListLabel(LlLanguage.Default))
            {
                using (var importUtil = new RepositoryImportUtil(CurrentRepository))
                {

                    rootId = importUtil.ImportProjectFile(LL, Path.GetFullPath("Base.lst"), "RootProject", null, null);
                    templateId = importUtil.ImportProjectFile(LL, Path.GetFullPath("LogoTemplate.lst"), "Template", null, null);
                }
            }

            btnRefreshRepoList.PerformClick();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            foreach (var item in CurrentRepository.GetAllItems())
            {
                listBox1.Items.Add(("[" + item.Type + "]").PadRight(20) + item.InternalID + " --> " + item.Descriptor);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            var prov = new ObjectDataProvider(new List<string>());

            using (var ll = new ListLabel())
            {
                ll.FileRepository = CurrentRepository;
                ll.DataSource = prov;
                ll.AutoProjectType = LlProject.List;

                using (ProjectList proj = new ProjectList(ll))
                {
                    proj.Open(rootId, LlDomFileMode.Open);
                    Template template = proj.ProjectTemplates.AddNew();
                    template.FileName = "'"+templateId+"'";
                    proj.Save();
                    proj.Close();
                }
                ll.Design(null, this.Handle, "Designer", LlProject.List, rootId, false);
            }
        }


        private void button4_Click(object sender, EventArgs e)
        {
            var list = CurrentRepository.GetAllItems().ToArray();
            foreach (var item in list)
                CurrentRepository.DeleteItem(item.InternalID);


            btnRefreshRepoList.PerformClick();
        }


        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.Save();
        }
    }

    internal enum HResult
    {
        E_NOTIMPL = -2147483648 + 0x4001,
        S_OK = 0,
        S_FALSE = 1,
        E_FAIL = -2147483648 + 0x4005,
        E_INVALIDARG = -2147483648 + 0x70057
    }

}
